SystemOrganization addCategory: #'BlackBoxParser-Expression'!
SystemOrganization addCategory: #'BlackBoxParser-test'!
SystemOrganization addCategory: #BlackBoxParser!

TestCase subclass: #BBParserStackTest
	instanceVariableNames: 'parser expectedStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

BBParserStackTest subclass: #BBP12Plus34Div56Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:42'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:42'!
testStep1

	parser sourceString: '('.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:42'!
testStep2

	parser sourceString: '(1'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBNumber new number: 1).
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:46'!
testStep25

	parser sourceString: '(12'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBNumber new number: 12).
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:46'!
testStep3

	parser sourceString: '(12+'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBAdd new left: (BBNumber new number: 12)).
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:47'!
testStep4

	parser sourceString: '(12+3'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 3)).
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:47'!
testStep5

	parser sourceString: '(12+34'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34)).
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 15:37'!
testStep6

	parser sourceString: '(12+34)'.
	parser run.
	expectedStack addFirst: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34))).
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 15:38'!
testStep7

	parser sourceString: '(12+34)/'.
	parser run.
	expectedStack addFirst: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34)))).
	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 15:40'!
testStep8

	parser sourceString: '(12+34)/5'.
	parser run.
	expectedStack addFirst: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34))); right: (BBNumber new number: 5)).

	self assert: expectedStack equals: parser stack.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 15:41'!
testStep9

	parser sourceString: '(12+34)/56'.
	parser run.
	expectedStack addFirst: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34))); right: (BBNumber new number: 56)).
	self assert: expectedStack equals: parser stack.! !

BBParserStackTest subclass: #BBP1Plus2Div3Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:41'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: expectedStack equals: parser stack.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:41'!
testStep1

	parser sourceString: '('.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	self assert: expectedStack equals: parser stack.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:41'!
testStep2

	parser sourceString: '(1'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBNumber new number: 1).
	self assert: expectedStack equals: parser stack.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:41'!
testStep3

	parser sourceString: '(1+'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBAdd new left: (BBNumber new number: 1)).
	self assert: expectedStack equals: parser stack.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:41'!
testStep4

	parser sourceString: '(1+2'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2)).
	self assert: expectedStack equals: parser stack.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:41'!
testStep5

	parser sourceString: '(1+2)'.
	parser run.
	expectedStack addFirst: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2))).
	self assert: expectedStack equals: parser stack.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:41'!
testStep6

	parser sourceString: '(1+2)/'.
	parser run.
	expectedStack addFirst: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2)))).
	self assert: expectedStack equals: parser stack.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:42'!
testStep7

	parser sourceString: '(1+2)/3'.
	parser run.
	expectedStack addFirst: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2))); right: (BBNumber new number: 3)).
	self assert: expectedStack equals: parser stack.! !

!BBParserStackTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 18:30'!
setUp

	parser := BlackBoxParser new.
	
	expectedStack := OrderedCollection new.! !

BBParserStackTest subclass: #BinaryExpressionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!BinaryExpressionTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 22:56'!
testAdd

	parser sourceString: '342+95'.
	parser run.
	expectedStack addFirst: (BBAdd new left: (BBNumber new number:342); right: (BBNumber new number:95)).
	self assert: expectedStack equals: parser stack.! !

!BinaryExpressionTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 22:56'!
testDivide

	parser sourceString: '2/6'.
	parser run.
	expectedStack addFirst: (BBDivide new left: (BBNumber new number:2); right: (BBNumber new number:6)).
	self assert: expectedStack equals: parser stack.! !

!BinaryExpressionTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 22:56'!
testMultiply

	parser sourceString: '2*6'.
	parser run.
	expectedStack addFirst: (BBMultiply new left: (BBNumber new number:2); right: (BBNumber new number:6)).
	self assert: expectedStack equals: parser stack.! !

!BinaryExpressionTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 22:56'!
testSubtract

	parser sourceString: '66-8'.
	parser run.
	expectedStack addFirst: (BBSubtract new left: (BBNumber new number:66); right: (BBNumber new number:8)).
	self assert: expectedStack equals: parser stack.! !

BBParserStackTest subclass: #DeepParenthesisParseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:25'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: expectedStack equals: parser stack.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:25'!
testStep1

	parser sourceString: '('.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	self assert: expectedStack equals: parser stack.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:25'!
testStep2

	parser sourceString: '(('.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBParenthesis new).
	self assert: expectedStack equals: parser stack.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:25'!
testStep3

	parser sourceString: '((('.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBParenthesis new).
	self assert: expectedStack equals: parser stack.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:26'!
testStep4

	parser sourceString: '(((7'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBNumber new number: 7).
	self assert: expectedStack equals: parser stack.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:26'!
testStep5

	parser sourceString: '(((7)'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBParenthesis new inner: (BBNumber new number: 7)).
	self assert: expectedStack equals: parser stack.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:27'!
testStep6

	parser sourceString: '(((7))'.
	parser run.
	expectedStack addFirst: (BBParenthesis new).
	expectedStack addFirst: (BBParenthesis new inner: (BBParenthesis new inner: (BBNumber new number: 7))).
	self assert: expectedStack equals: parser stack.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:27'!
testStep7

	parser sourceString: '(((7)))'.
	parser run.
	expectedStack addFirst: (BBParenthesis new inner: (BBParenthesis new inner: (BBParenthesis new inner: (BBNumber new number: 7)))).
	self assert: expectedStack equals: parser stack.! !

BBParserStackTest subclass: #NumberBlackBoxParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!NumberBlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:26'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: expectedStack equals: parser stack.! !

!NumberBlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:27'!
testStep1

	parser sourceString: '1'.
	parser run.
	expectedStack addFirst: (BBNumber new number: 1).
	self assert: expectedStack equals: parser stack.! !

!NumberBlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:28'!
testStep2

	parser sourceString: '12'.
	parser run.
	expectedStack addFirst: (BBNumber new number: 12).
	self assert: expectedStack equals: parser stack.! !

!NumberBlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:21'!
testStep3

	parser sourceString: '123'.
	parser run.
	expectedStack addFirst: (BBNumber new number: 123).
	self assert: expectedStack equals: parser stack.! !

Object subclass: #BBExpression
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBExpression class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

BBExpression subclass: #BBBinaryExpression
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBBinaryExpression subclass: #BBAdd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:12'!
gettersForEquality
	
	^#(left right)! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 22:06'!
isBinaryExpression

	^true! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 22:07'!
isComplete

	^left notNil and: [right notNil]! !

!BBBinaryExpression methodsFor: 'accessing' stamp: 'hjo 8/11/2012 21:15'!
left

	^left! !

!BBBinaryExpression methodsFor: 'accessing' stamp: 'hjo 8/11/2012 16:54'!
left: aBBNumber 

	left := aBBNumber! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:15'!
right

	^right! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:55'!
right: aBBNumber 

	right := aBBNumber! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 15:24'!
rightIsNil

	^right isNil! !

BBBinaryExpression subclass: #BBDivide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBBinaryExpression subclass: #BBMultiply
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBBinaryExpression subclass: #BBSubtract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 22:03'!
isBinaryExpression

	^false! !

!BBExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:49'!
isNumberExpression

	^false! !

BBExpression subclass: #BBNumber
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:10'!
gettersForEquality

	^#(number)! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 10:18'!
isNumberExpression

	^true! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:10'!
number

	^number! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:54'!
number: aNumber 

	number := aNumber! !

BBExpression subclass: #BBParenthesis
	instanceVariableNames: 'inner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:54'!
gettersForEquality

	^#(inner)! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:55'!
inner 

	^inner! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:55'!
inner: aBBAdd 

	inner := aBBAdd! !

BBExpression subclass: #BBTerm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBExpression subclass: #BBVacancy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

Object subclass: #BlackBoxParser
	instanceVariableNames: 'stream stack parsingDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser'!

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/13/2012 10:42'!
ifExpressionOfTopOfStackIsBinaryExpressionWithNilRight: aBlockClosure ifRightOfBinaryExpressionIsNumberExpression: aBlockClosure4 ifExpressionOfTopOfStackIsNumberExpression: aBlockClosure2 else: aBlockClosure3 

	| el |
	el := [stack first isNumberExpression
									ifTrue: [aBlockClosure2 value: stack first]
									ifFalse: aBlockClosure3 ].
	
	stack isEmpty ifTrue: [^aBlockClosure3 value].
	
	stack first isBinaryExpression 
		ifTrue: [stack first rightIsNil
					ifTrue: aBlockClosure
					ifFalse: [
						stack first right isNumberExpression
							ifTrue: [ aBlockClosure4 value:  stack first right ]
							ifFalse: el]]
		ifFalse: el! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 14:22'!
initialize

	super initialize.
	stack := OrderedCollection new.
	self makeParsingDictionary.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 18:37'!
makeParsingDictionary

	parsingDictionary := Dictionary new.
	
	parsingDictionary 
		at: $( put: 
		[stack addFirst: BBParenthesis new].

	parsingDictionary 
		at: $) put: 
		[ | inex |
		inex := stack removeFirst.
		stack first inner: inex ].

	'1234567890' do: [:digit|
		parsingDictionary 
			at: digit put: 
			[ |n| 
			n := BBNumber new number: digit digitValue.
			self
				ifExpressionOfTopOfStackIsBinaryExpressionWithNilRight: [stack first right: n]
				ifRightOfBinaryExpressionIsNumberExpression: [:numExpression| numExpression number: numExpression number * 10 + digit digitValue ]
				ifExpressionOfTopOfStackIsNumberExpression: [:numExpression| numExpression number: numExpression number * 10 + digit digitValue ]
				else: [stack addFirst: n] ] ].

	parsingDictionary 
		at: $+ put: 
		[stack addFirst: (BBAdd new left: (stack removeFirst))].

	parsingDictionary 
		at: $- put: 
		[stack addFirst: (BBSubtract new left: (stack removeFirst))].

	parsingDictionary 
		at: $* put: 
		[stack addFirst: (BBMultiply new left: (stack removeFirst))].

	parsingDictionary 
		at: $/ put: 
		[stack addFirst: (BBDivide new left: (stack removeFirst))].
! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:07'!
run

	[self step] whileTrue.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:41'!
sourceString: aString 

	stream := aString readStream.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:53'!
stack

	^ stack! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 18:18'!
step

	stream atEnd ifTrue: [^false].
	(parsingDictionary at: stream next) value.
	^true! !
